#include <Array.au3>

Opt("MustDeclareVars", 1)

Demo_1()

Func Demo_1()

  Local $sFilePath

;   $sFilePath = "C:\Program Files (x86)\AutoIt3\SciTE\AutoIt3Wrapper\AutoIt3Wrapper.au3"
  $sFilePath = @ScriptDir & "\_Test-Datei GUIScrollbars_Ex.au3"

  Local $aFlist = RemoveComments_1($sFilePath)
EndFunc


; ==============================================================================
; Demo - remove nested block comments.
;
; Professor Bernd, 2020-06-29.
; ------------------------------------------------------------------------------
Func RemoveComments_1($_sFilePath)

  Local $aFuncs

  ; Datei komplett einlesen.
  Local $sAllLines = FileRead($_sFilePath)

  If $sAllLines = '' Then Return SetError(1, 0, '')

  ; Fr Debug:
  ClipPut("") ; ClipBoard leeren.

;   ; --------------------------------------------------------------------------
;   ; Strip single line comments.
;   ; mikell, https://www.autoitscript.com/forum/topic/157255-regular-expression-challenge-for-stripping-single-comments/?do=findComment&comment=1138772
;   $sAllLines = StringRegExpReplace($sAllLines, '(?m)^((?:[^''";]*([''"]).*?\2)*[^;]*);?.*$', '$1')
;
;   ; Remove block comments (#cs or #comment-start & #ce or #comment-end).
;   ; Autor: guinness, 2013-02-13.
;   ; https://www.autoitscript.com/forum/topic/148213-parse-all-includes-in-a-script-file/?do=findComment&comment=1053486
;   $sAllLines = StringRegExpReplace($sAllLines, _
;     '(?is)(\n\h*#(?:cs|comments?-start)[^\n]*\n.*?\n\h*#(?:ce|comments?-end)[^\n]*)', "")
;
;   ; Remove nested block comments.
;   _stripComments($sAllLines)
;   ; --------------------------------------------------------------------------


  ; Alle Kommentare entfernen(?)
  ; Autor: AspirinJunkie
  ; https://autoit.de/thread/86962-ausbalanzierte-stringsequenzen/?postID=700037#post700037
  $sAllLines = StringRegExpReplace($sAllLines, '((?m)^\h*\#(?>cs|comments-start)\b(?:(?sU)(?:(?R)|.)*)^\h*\#(?>ce|comments-end)\b.+\R|(?m)^(?>(?<!")"(?>"")*.*?(?<!")"(?>"")*(?!")|(?<!'')''(?>'''')*.*?(?<!'')''(?>'''')*(?!'')|[^\;\r\n])*?\K\h*\;.*$)', '')

  ; ==== Hier hngt sich das Script auf. 2020-06-29. ====


  ; Mehrfache Leerzeilen durch eine einzelne ersetzen.
  $sAllLines = StringRegExpReplace($sAllLines, "(\h*\R){2,}", @CRLF & @CRLF)

  ; Fr Debug:
  ClipPut($sAllLines)
  ConsoleWrite(@CRLF & '! => Bereinigtes Script wurde ins ClipBoard kopiert.' & @CRLF & @CRLF)
EndFunc ; ==> ReadOUDFsFromFile


; ==============================================================================
; Autor: Prog@ndy, 201-01-22.
; https://www.autoitscript.com/forum/topic/108728-_stripcomments/?do=findComment&comment=765712
; https://github.com/AutoIt/SublimeAutoItScript/blob/master/Include_Helper.au3
; ------------------------------------------------------------------------------
Func _stripComments(ByRef $string)

  ;Author: Prog@ndy
;   $string = StringReplace(StringReplace($string, "#comments-start", "#cs", 0, 2), "#comments-end", "#ce", 0, 2)
  ;
  ; Modifiziert von Professor Bernd, 2020-06-29.
  $string = StringRegExpReplace($string, "(?im)^(\h*)#comments-start(.*\R)", '\1#cs\2')
  $string = StringRegExpReplace($string, "(?im)^(\h*)#comments-end(.*\R)", '\1#ce\2')

;   $string = StringRegExpReplace($string, "(?si)(\v|\A)\h*#cs\b.*?\v\h*#ce\b", '') ; remove simple block comments ( AZJIO)
  #region remove nested block-comments
  Local $match, $depth, $offset, $start, $CommentsAfterce
  While 1
    $depth = 0
    $match = StringRegExp($string, "(?im)^\h*#cs\b", 1)
    $start = @extended
    If @error Then ExitLoop
    Do
      $match = StringRegExp($string, "(?im)^\h*#c([se])\b", 1, $offset)
      $offset = @extended
      Select
        Case @error
          Return False
        Case $match[0] = "e"
          $depth -= 1
        Case Else
          $depth += 1
      EndSelect
    Until $depth < 1

    $string = StringLeft($string, $start - 4) & StringRegExpReplace(StringMid($string, $offset), ".*", '', 1)
;~         $string = StringLeft($string, $start-4) & StringMid($string, $offset)
  WEnd
  #endregion remove nested block-comments
;   $string = StringRegExpReplace($string, '(?m)^((?:[^''";]*([''"]).*?\2)*[^;]*);.*$', '\1') ; remove one-line comments
  Return True
EndFunc ;==>_stripComments


